
if exists (select * from sysobjects where id = object_id(N'f_GetDepreciationValue') and xtype in (N'FN', N'IF', N'TF'))
begin
	drop function f_GetDepreciationValue
end
go

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE function dbo.f_GetDepreciationValue
(
	@OriginalAmount numeric(18, 2),
	@ObtainDate datetime,
	@CurrentDate datetime,
	@DepreciationRate numeric(18, 2)
)
returns numeric(18, 2)
as -- select @OriginalAmount = 10000, @ObtainDate = '',	@CurrentDate = GetDate(), @DepreciationRate = 8
begin
	declare @Result numeric(18, 2)
	if IsNull(@DepreciationRate,0)=0 or (@ObtainDate is null) 
		return 0
	if @ObtainDate >= @CurrentDate
		return 0
	select @Result = @OriginalAmount*DATEDIFF(day, @ObtainDate, @CurrentDate)*0.01*@DepreciationRate/365.25
	if @Result<0
		select @Result=0
	return @Result
end


GO




