

if exists(select * from sysobjects where id = object_id('v_InventoryUniqueCode') and OBJECTPROPERTY(id, 'IsView') = 1)
begin
	drop View v_InventoryUniqueCode
end
go

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

Create View dbo.v_InventoryUniqueCode
as
	
	select a.WarehouseNo, c.GoodsNo, c.ColorNo, c.SizeNo, a.UniqueCode, cast(null as datetime) as ProductionDate, a.Quantity 
	from UniqueCodeLog a
		inner join (
			select UniqueCode, max(SerialNo) as SerialNo
			from UniqueCodeLog
			group by UniqueCode
		) b on a.UniqueCode=b.UniqueCode and a.SerialNo=b.SerialNo 
		left join GoodsUniqueCode c on a.UniqueCode=c.UniqueCode 
	where IsNull(a.Quantity ,0)<>0
	
GO



if exists(select * from sysobjects where id = object_id('v_Inventory') and OBJECTPROPERTY(id, 'IsView') = 1)
begin
	drop View v_Inventory
end
go

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

Create View dbo.v_Inventory
as

	select a.WarehouseNo, a.GoodsNo, a.ColorNo, a.SizeNo, cast(null as varchar(255)) as UniqueCode, ProductionDate, Quantity 
	from InventoryProductionDate a
	where IsNull(a.Quantity ,0)<>0
	
	union all
	
	select a.WarehouseNo, GoodsNo, ColorNo, SizeNo, a.UniqueCode, ProductionDate, a.Quantity 
	from v_InventoryUniqueCode a
	
	union all
	
	select a.WarehouseNo, a.GoodsNo, a.ColorNo, a.SizeNo, Null as UniqueCode, Null as ProductionDate, IsNull(a.Quantity,0)-IsNull(b.Quantity,0) as Quantity
	from Inventory a
		left join (
			select GoodsNo, ColorNo, SizeNo,sum(Quantity) as Quantity from (
				select a.WarehouseNo, a.GoodsNo, a.ColorNo, a.SizeNo, cast(null as varchar(255)) as UniqueCode, ProductionDate, Quantity 
				from InventoryProductionDate a
				where IsNull(a.Quantity ,0)<>0
				
				union all
				
				select a.WarehouseNo, a.GoodsNo, a.ColorNo, a.SizeNo, a.UniqueCode, ProductionDate, a.Quantity 
				from v_InventoryUniqueCode a
			) a
			group by GoodsNo, ColorNo, SizeNo
		) b on a.GoodsNo=b.GoodsNo and a.ColorNo=b.ColorNo and a.SizeNo=b.SizeNo
	where IsNull(a.Quantity,0) > IsNull(b.Quantity,0)

GO





